PrefabFiles = {
	"winnie",
	"winnie_none",
	"magicseeds",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/winnie.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/winnie.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/winnie.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/winnie.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/winnie_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/winnie_silho.xml" ),

    Asset( "IMAGE", "bigportraits/winnie.tex" ),
    Asset( "ATLAS", "bigportraits/winnie.xml" ),
	
	Asset( "IMAGE", "images/map_icons/winnie.tex" ),
	Asset( "ATLAS", "images/map_icons/winnie.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_winnie.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_winnie.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_winnie.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_winnie.xml" ),
	
	Asset( "IMAGE", "images/avatars/self_inspect_winnie.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_winnie.xml" ),
	
	Asset( "IMAGE", "images/names_winnie.tex" ),
    Asset( "ATLAS", "images/names_winnie.xml" ),
	
    Asset( "IMAGE", "bigportraits/winnie_none.tex" ),
    Asset( "ATLAS", "bigportraits/winnie_none.xml" ),
	
	Asset("SOUNDPACKAGE", "sound/winnie.fev"),
    Asset("SOUND", "sound/winnie.fsb"),

}

RemapSoundEvent( "dontstarve/characters/winnie/talk_LP", "winnie/winnie/talk_LP" )
RemapSoundEvent( "dontstarve/characters/winnie/hurt", "winnie/winnie/hurt" )
RemapSoundEvent( "dontstarve/characters/winnie/death_voice", "winnie/winnie/death_voice" )
RemapSoundEvent( "dontstarve/characters/winnie/yawn", "winnie/winnie/yawn" )
RemapSoundEvent( "dontstarve/characters/winnie/emote", "winnie/winnie/emote" )
RemapSoundEvent( "dontstarve/characters/winnie/pose", "winnie/winnie/pose" )
RemapSoundEvent( "dontstarve/characters/winnie/ghost_LP", "winnie/winnie/ghost_LP" )

local Ingredient = GLOBAL.Ingredient
local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

-- The character select screen lines
STRINGS.CHARACTER_TITLES.winnie = "The Shepherd Girl"
STRINGS.CHARACTER_NAMES.winnie = "Winnie"
STRINGS.CHARACTER_DESCRIPTIONS.winnie = "*Loves, and is loved by animals\n*Has a magical seed pouch\n*Won't eat meat"
STRINGS.CHARACTER_QUOTES.winnie = "\"Little Bo-Peep has lost her sheep.\""

-- Custom speech strings
STRINGS.CHARACTERS.WINNIE = require "speech_winnie"

-- The character's name as appears in-game 
STRINGS.NAMES.WINNIE = "Winnie"

AddMinimapAtlas("images/map_icons/winnie.xml")

-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("winnie", "FEMALE")

local function RestoreTag(inst)	if 
GLOBAL.TheWorld.ismastersim then		
local function _RT(inst, data)			
if data.owner and data.owner.prefab == "winnie"
then				
data.owner:AddTag("beefalo")			
end				end		
inst:ListenForEvent("unequipped", _RT)	
end
end

AddPrefabPostInit("beefalohat", RestoreTag)

local ACTIONS = GLOBAL.ACTIONS
local TUNING = GLOBAL.TUNING

local function MakeItForBeeWhisperer(inst)
	local _Pick = inst.components.pickable.Pick
	inst.components.pickable.Pick = function(self, picker)
		if picker and not picker:HasTag("beewhisperer") then
			return
		end
		return _Pick(self, picker)
	end

	inst:AddTag("forbeewhisperer")
end

AddPrefabPostInit("beehive", function(inst)
	if not GLOBAL.TheWorld.ismastersim then
		return
	end

	inst:AddComponent("pickable")
	inst.components.pickable:SetUp("honey", TUNING.GRASS_REGROW_TIME)

	MakeItForBeeWhisperer(inst)
end)

local function RemovePickableActionFrom(t)
	local k = 0
	local pickact = ACTIONS.PICK
	for i, v in ipairs(t) do
		if v.action == pickact then
			k = i
			break
		end
	end
	if k ~= 0 then
		table.remove(t, k)
	end
end

local EntityScript = GLOBAL.EntityScript

AddComponentPostInit("playeractionpicker", function(self)
	local _SortActionList = self.SortActionList
	self.SortActionList = function(self, actions, target, useitem)
		local ret = _SortActionList(self, actions, target, useitem)
		if target and target:is_a(EntityScript) and target:HasTag("forbeewhisperer") and not self.inst:HasTag("beewhisperer") then
			RemovePickableActionFrom(ret)
		end
		return ret
	end
end)

local EntityScript = GLOBAL.EntityScript
local _GetAdjective = EntityScript.GetAdjective
function EntityScript:GetAdjective()
	if self:HasTag("specialrot") then
		local ret = nil
		if self:HasTag("stale") then
			ret = ""
		elseif self:HasTag("spoiled") then
			ret = ""
		end
		return ret
	end
	return _GetAdjective(self)
end

STRINGS.NAMES.MAGICSEEDS = "Magic Seed Pouch"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGICSEEDS = "A magical pouch of seeds."
STRINGS.CHARACTERS.WILLOW.DESCRIBE.MAGICSEEDS = "Never ending vegetables? Yuck."
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.MAGICSEEDS = "This bag hold more than my mighty belly!"
STRINGS.CHARACTERS.WENDY.DESCRIBE.MAGICSEEDS = "It's a gaping hole of emptiness filled by seeds."
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.MAGICSEEDS = "How can that bag hold a universe worth of seeds?"
STRINGS.CHARACTERS.WX78.DESCRIBE.MAGICSEEDS = "IT IS CAPABLE OF INFINITLEY PRODUCING ORGANIC MATTER"
STRINGS.CHARACTERS.WOODIE.DESCRIBE.MAGICSEEDS = "Too bad it doesn't grow infinite trees for me to chop!"
STRINGS.CHARACTERS.WAXWELL.DESCRIBE.MAGICSEEDS = "I believe this originates from a fairy tale."
STRINGS.CHARACTERS.WEBBER.DESCRIBE.MAGICSEEDS = "We wonder how it works!"
STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.MAGICSEEDS = "Infinite vegetables is a curse!"
STRINGS.CHARACTERS.WINNIE.DESCRIBE.MAGICSEEDS = "A man sold me magic seeds that never stop growing!"
